/**
 * Copyright (C) 2003-2004 Funambol
 *
 *  This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 */
package sync4j.syncclient.spdm;

/**
 * This interface represents a Device in a generic manner.
 *
 * @author  Stefano Fornari
 * @version $Id: Device.java,v 1.1.1.1 2004/04/09 11:23:04 fabius Exp $
 */
public interface Device {
    
    /**
     * Returns the base directory, so that the common parent directory of 
     * the relative paths used in the device manager and other modules.
     * The way the current directory is detected is device specific.
     *
     * @return the current working directory as a string.
     *
     * @throws DMException if there is an error in determining the current 
     *         working directory.
     */
    public String getBaseDirectory() throws DMException;
    
    /**
     * Sets the device base directory
     * 
     * @param the new base directory. 
     *
     * @throws DMException in case of error setting the base direcotry
     */
    public void setBaseDirectory(String baseDir) throws DMException;
}